use strict;
use warnings;
$|++;
use IO::Socket::INET;

my $stage = 0;
my $desx = 0;
my $desy = 0;
my $homex = 0;
my $homey = 0;
my $curpack = 0;
my $traceon = 0;
my $lastdir = 0;
if (scalar @ARGV < 2) {
	print "Forgot hostname / port!";
	exit 1;
}
my $host = $ARGV[0];
my $port = $ARGV[1];
my $socket = IO::Socket::INET->new(PeerAddr => $host,
				   PeerPort => $port,
				   Proto    => "tcp",
				   Type     => SOCK_STREAM)
	or die "Couldn't connect to $host:$port : $!\n";

print $socket "Player\n";

my $size = <$socket>;
my ($width, $height) = split / /, $size;
my @board;
my @overlay;
for my $x (0 .. $height-1) {
	my $curstring = <$socket>;
	chomp $curstring; 
	my @arr = split //, $curstring;
	foreach my $y (0 .. $width-1) {
		if ($arr[$y] eq "@") {
			$desx = $x;
			$desy = $y;
		}
	}
	push @board, \@arr;
}
my $initinfo = <$socket>;
my ($robonum, $maxweight, $money) = split / /, $initinfo;
my ($curposx, $curposy);
my $locinfo = <$socket>;
chomp $locinfo;
my @locs = split /#/, $locinfo;
shift @locs;
foreach (@locs) {
	my ($currob, $posx, $posy) = /([0-9]+) X ([0-9]+) Y ([0-9]+)/;
	$posx--; $posy--;
	if ($currob == $robonum) {
		$curposx = $posx;
		$curposy = $posy;
		$overlay[$curposx][$curposy] = $robonum;
	}
}
#for my $i (0 .. $height-1) {
	#	for my $j (0 .. $width-1) {
		#	if (exists $overlay[$i][$j]) {
			#	print $overlay[$i][$j];
			#} else {
				#print $board[$i][$j];
				#}
				#}
				#print "\n";
				#}
my $x;
do {
	my $packagesstr = <$socket>;
	chomp $packagesstr;
	my @package = split / /, $packagesstr;
	my @packages;
	for ($x = 0; $x <= $#package; $x+=4) {
		my @arr = ($package[$x], $package[$x+1], $package[$x+2], $package[$x+3]);
		push @packages, \@arr;
	}
	my $move = getmove($curposx, $curposy, @packages);
	#print $move, "\n";
	print $socket $move, "\n";
	my $newstate = <$socket>;
	#print $newstate;
	chomp $newstate;
	my @states = split /#/, $newstate;
	shift @states;
	foreach (@states) {
		my @state = split / /;
		for ($x = 1; $x <= $#state ; $x+=2) {
			$overlay[$curposx][$curposy] = "";
			if ($state[0] == $robonum) {
				if ($state[$x] =~ /[NEWS]/) {
					#print $state[$x], "\n";
					if ($state[$x] eq "N") {
						$curposx++;
					}
					if ($state[$x] eq "E") {
						$curposy++;
					}
					if ($state[$x] eq "S") {
						$curposx--;
					}
					if ($state[$x] eq "W") {
						$curposy--;
					}
					$x--;
				}
			}
			$overlay[$curposx][$curposy] = $robonum;
		}	
	}	
	#for my $i (0 .. $height-1) {
		#for my $j (0 .. $width-1) {
			#if (exists $overlay[$i][$j] && $overlay[$i][$j] ne "") {
				#print $overlay[$i][$j];
				#} else {
					#print $board[$i][$j];
					#}
					#}
					#print "\n";
		#}
} while (!($socket->eof()));

close($socket);

sub getmove {
	my ($posx, $posy, @packages) = @_;
	if ($posx == $desx && $posy == $desy) {
		$stage++;
	}
	if ($stage == 0) {
		return "1 " . pathfind($posx, $posy);
	} elsif ($stage == 1)  {
		$homex = $desx;
		$homey = $desy;
		my $package = shift @packages;
		$curpack = @$package[0];
		$desx = @$package[2]-1;
		$desy = @$package[1]-1;
		$stage++;
		return "1 Pick " . $curpack;
	} elsif ($stage == 2) {
		return "1 " . pathfind($posx, $posy);
	} else {
		$desx = $homex;
		$desy = $homey;
		$stage = 0;
		return "1 Drop " . $curpack;
	}
}

#EWNS
#1234
sub pathfind {
	my ($posx, $posy) = @_;
	my @dirs = ("Move E", "Move W", "Move N", "Move S");
	if ($traceon != 0) {
		#print $traceon, "\n";
		if ($traceon == 1) {
			if (islegal($posx, $posy+1)) {
				$traceon = 0;
				return $dirs[0]
			} 
			if ($lastdir == 2) {
				if (!(islegal($posx+1, $posy))) {
					$lastdir = 3;
				}
				return $dirs[$lastdir];
			} elsif ($lastdir == 3) {
				if (!(islegal($posx-1, $posy))) {
					$lastdir = 2;
				}
				return $dirs[$lastdir];
			}
		} elsif ($traceon == 2) {
			if (islegal($posx, $posy-1)) {
				$traceon = 0;
				return $dirs[1];
			}
			if ($lastdir == 2) {
				if (!(islegal($posx+1, $posy))) {
					$lastdir = 3;
				}
				return $dirs[$lastdir];
			} elsif ($lastdir == 3) {
				if (!(islegal($posx-1, $posy))) {
					$lastdir = 2;
				}
				return $dirs[$lastdir];
			}
		} elsif ($traceon == 3) {
			if (islegal($posx, $posy+1)) {
				$traceon = 0;
				return $dirs[2];
			}
			if ($lastdir == 0) {
				if (!(islegal($posx, $posy+1))) {
					$lastdir = 1;
				}
				return $dirs[$lastdir];
			} elsif ($lastdir == 1) {
				if (!(islegal($posx, $posy-1))) {
					$lastdir = 0;
				}
				return $dirs[$lastdir];
			}
		} elsif ($traceon == 4) {
			if (islegal($posx-1, $posy)) {
				$traceon = 0;
				return $dirs[3];
			}
			if ($lastdir == 0) {
				if (!(islegal($posx, $posy+1))) {
					$lastdir = 1;
				}
				return $dirs[$lastdir];
			} elsif ($lastdir == 1) {
				if (!(islegal($posx, $posy-1))) {
					$lastdir = 0;
				}
				return $dirs[$lastdir];
			}
		}
	}
	if ($posy < $desy) {
		if (islegal($posx, $posy+1)) {
			return "Move E";
		} else {
			$traceon = 1;
			$lastdir = 3;
			return $dirs[$lastdir];
		}
	}
	if ($posy > $desy) {
		if (islegal($posx, $posy-1)) {
			return "Move W";
		} else {
			$traceon = 2;
			$lastdir = 2;
			return $dirs[$lastdir];
		}
	}
	if ($posx < $desx) {
		if (islegal($posx+1, $posy)) {
			return "Move N";
		} else {
			$traceon = 3;
			$lastdir = 1;
			return $dirs[$lastdir];
		}
	} 
	if ($posx > $desx) {
		if (islegal($posx-1, $posy)) {
			return "Move S";
		} else {
			$traceon = 4;
			$lastdir = 0;
			return $dirs[rand 4];
		}
	}									
}

sub islegal {
	my ($posx, $posy) = @_;
	if ($board[$posx][$posy] eq "#" ||
	    $board[$posx][$posy] eq "~") {
		    return 0;
	} else {
		return 1;
	}
}
